<!-- This page presents a form to the user with text inputs for each field in the database. When the user selects the Add button, the form information is submitted to a response page with an [Inline] tag that adds a record to the database with the values the user specified. -->

<!-- The [Auth] tag prompts for a username and password if the current user is not logged in with a username present in Lasso Security. User accounts are configured in Lasso Administration LassoApp (admin.lassoapp), or in the Group Administration LassoApp (groupadmin.lassoapp). For more information on the [Auth] tag, see Chapter 22 in the Lasso 7 Language Guide PDF. -->

[Auth]

[Include:'header.lasso']

<form action="addresponse.lasso" method="POST">
	<table bgcolor="#FFFFFF" cellspacing="1" cellpadding="5" width="550" border="0">
		<tr>
			<td colspan="2"> <h2>Add Record</b></h2>
	[Inline: (Action_Params), -Database='Example_DB', -Table='web', -KeyField='id', -Show]
 </td>
		</tr>
		<tr>
			<td><b> Address </b></td>
			<td> <input type="text" name="address" value="[Action_Param: 'address']"></input> </td>
		</tr>
		<tr>
			<td><b> City </b></td>
			<td> <input type="text" name="city" value="[Action_Param: 'city']"></input> </td>
		</tr>
		<tr>
			<td><b> Company </b></td>
			<td> <input type="text" name="company" value="[Action_Param: 'company']"></input> </td>
		</tr>
		<tr>
			<td><b> Description </b></td>
			<td> <textarea name="description" rows="5" cols="35">[Action_Param: 'description']</textarea> </td>
		</tr>
		<tr>
			<td><b> Phone </b></td>
			<td> <input type="text" name="phone" value="[Action_Param: 'phone']"></input> </td>
		</tr>
		<tr>
			<td><b> State </b></td>
			<td> <input type="text" name="state" value="[Action_Param: 'state']"></input> </td>
		</tr>
		<tr>
			<td><b> URL </b></td>
			<td> <input type="text" name="url" value="[Action_Param: 'url']"></input> </td>
		</tr>
		<tr>
			<td><b> Zip </b></td>
			<td> <input type="text" name="zip" value="[Action_Param: 'zip']"></input> </td>
		</tr>
		<tr>
			<td><b> Country </b></td>
			<td> <input type="text" name="country" value="[Action_Param: 'country']"></input> </td>
		</tr>
		<tr>
			<td colspan="2"> 
			<p>&nbsp;</p>
			
	<!-- The Name attribute if the Add button contains a named -Token tag, which informs a conditional [If] tag in the response page what action needs to be performed. The token value is specified in the Value attribute of the <Input> tag. -->		
			
	<input type="submit" name="-Token.Action" value="Add Record">
	</input>
	[/Inline]
 </td>
		</tr>
	</table>
</form>

[Include:'footer.lasso']
