<!-- This page is a form with text inputs for each field in the database. When the page is loaded, values from the appropriate fields in the database are retrieved and automatically inserted into the text input fields. These values can be edited and when the user selects the Update button the values will be updated in the fields for the current record in the database. -->

[Auth]

[Include:'header.lasso']

<form action="updateresponse.lasso" method="POST">
	<table bgcolor="#FFFFFF" cellspacing="1" cellpadding="5" width="550" border="0">
		<tr>
			<td colspan="2"> <h2>Update Record</b></h2>
			
	<!-- The [If] and [Inline] LDML objects perform a -Search or -Add action on the database (depending on the previous page) to populate the text fields with record data. The [Inline] tags will populate the fields with record data based on information submitted by a previous page. -->		
			
	[If: (Token_Value: 'Action') >> 'Add'][Variable: 'Action'=-Add][Else: (Token_Value: 'Action') >> 'Find All'][Variable: 'Action'=-FindAll][Else][Variable: 'Action'=-Search][/If]
	[Inline: (Action_Params), -Database='Example_DB', -Table='web', -KeyField='id', $Action]
<input type="hidden" name="-KeyValue" value="[KeyField_Value]"/> </td>
		</tr>
		<tr>
			<td colspan="2"> 	
			
		<!-- Another [If] statement is used to display an error message if an error occurs when loading or using the page. The [Error_CurrentError] tag displays the current Lasso error message. For more information on error tags, see Chapter 21 in the Lasso 7 Language Guide. -->	
			
			[If: (Error_CurrentError) != (Error_NoError)]An error has occurred. ([Error_CurrentError: -ErrorCode] [Error_CurrentError])[/If]
 </td>
		</tr>
		
		<!-- The values from the fields in the current database record are placed in the text inputs. In the example below, the substitution tag [Field: 'Address'] places the value for the field Address from the record which was just added to the database into the text input so the user can make changes. -->
		
		<tr>
			<td><b> Address </b></td>
			<td> <input type="text" name="address" value="[Field: 'address']"></input> </td>
		</tr>
		<tr>
			<td><b> City </b></td>
			<td> <input type="text" name="city" value="[Field: 'city']"></input> </td>
		</tr>
		<tr>
			<td><b> Company </b></td>
			<td> <input type="text" name="company" value="[Field: 'company']"></input> </td>
		</tr>
		<tr>
			<td><b> Description </b></td>
			<td> <textarea name="description" rows="5" cols="35">[Field: 'description']</textarea> </td>
		</tr>
		<tr>
			<td><b> Phone </b></td>
			<td> <input type="text" name="phone" value="[Field: 'phone']"></input> </td>
		</tr>
		<tr>
			<td><b> State </b></td>
			<td> <input type="text" name="state" value="[Field: 'state']"></input> </td>
		</tr>
		<tr>
			<td><b> URL </b></td>
			<td> <input type="text" name="url" value="[Field: 'url']"></input> </td>
		</tr>
		<tr>
			<td><b> Zip </b></td>
			<td> <input type="text" name="zip" value="[Field: 'zip']"></input> </td>
		</tr>
		<tr>
			<td><b> Country </b></td>
			<td> <input type="text" name="country" value="[Field: 'country']"></input> </td>
		</tr>
		<tr>
			<td colspan="2"> 
			<p>&nbsp;</p>
			
	<!-- Finally, the button names contain named -Token tags which will inform the response page what action needs to be performed. Each button will submit a different token value, which is specified in the Value attribute of the <Input> tag. The Update.lasso page has an option to delete the record which is currently being shown. If the Delete button is selected, then the record will be deleted in the UpdateResponse.lasso page instead of updated. -->		
			
	<input type="submit" name="-Token.Action" value="Update Record">
	</input>
	<input type="submit" name="-Token.Action" value="Delete Record">
	</input>
	[/Inline]
 </td>
		</tr>
	</table>
</form>

[Include:'footer.lasso']
