#include "TestTag.h"
#include <string.h>

#include	<stdio.h>

#if MACHINE_PC
#else
#define	stricmp	strcasecmp
#endif

void registerLassoModule()
{
	lasso_registerTagModule( "CAPITester", "test_tag", tagFunc, flag_typeSubstitutionTag, "test tag" );
	lasso_registerTagModule( "CAPITester", "echo", tagFunc, flag_typeSubstitutionTag, "echo tag" );
}

osError
tagFunc( lasso_request_t token, tag_action_t action )
{
	if ( action == tagFormatSubstitution )
	{
		auto_lasso_value_t v;
		lasso_getTagName( token, &v );
		if ( stricmp(v.data, "echo") == 0 )
		{
			int num;
			lasso_getTagParamCount(token, &num);
			if ( num > 0 )
			{
				lasso_getTagParam(token, 0, &v);
				lasso_outputTagData(token, v.name);
			}
		}
		else
		{
			int num, x;
			osError err;

			lasso_getTagParamCount( token, &num );
			lasso_getTagName(token, &v);
			lasso_outputTagDataF(token, "%s%s%d%s", v.data, "<BR>Param count: ", num, "<BR>");
			
			for ( x = 0; x < num; ++x )
			{
				if ( lasso_getTagParam(token, x, &v) == osErrNoErr )
				{
					auto_lasso_value_t tst;
					lasso_outputTagDataF(token, "%s=%s Defined: %d Found: %d%s", v.name, v.data, lasso_tagParamIsDefined(token, v.name) == osErrNoErr ? 1 : 0, lasso_findTagParam(token, v.name, &tst) == osErrNoErr ? 1 : 0, "<BR>");
				}
			}

			lasso_getRequestParam(token, rpFileName, &v);
			lasso_outputTagDataF(token, "<p><p>Let's get a request param: %s<p>", v.data);

			lasso_outputTagData(token, "Let's do some formatting!<br>");

			err = lasso_formatBuffer(token, "This is the server date: [server_date]<br>Browser type: [client_type]. Yo!<p>", &v);
			if ( err == osErrNoErr )
				lasso_outputTagData(token, v.data);
			else
				lasso_outputTagDataF(token, "Got an error formatting: %d<p>", err);
		}
	}
	return osErrNoErr;
}
