<?LassoScript

//
// Variables
//

_admin_addvar: 'groups_action', -default='None', -override=(action_param: 'groups_action', (action_param: 'groups_action', -count));
_admin_addvar: 'groups_skip', -default=1, -session='_admin', -override=(action_param: 'groups_skip');
_admin_addvar: 'groups_navigation', -override=(action_param: 'groups_navigation');
_admin_addvar: 'groups_jump', -override=(action_param: 'groups_jump');
_admin_addvar: 'groups_actionid', -default=$groups_hostid, -override=(action_param: 'groups_actionid');
_admin_addvar: 'host_sql', -override=(action_param: 'host_sql');
_admin_addvar: 'dialog_action', -default='None', -override=(action_param: 'dialog_action');

//
// Process Action
//

if: ($groups_action >> 'Assign') || ($groups_action >> 'Unassign') || ($dialog_action >> 'Unassign All');

	if: ($groups_action >> 'Unassign') || ($dialog_action >> 'Unassign All');
		var: 'host_sql' = 'Ignore';
	/if;

	if: !($host_sql >> 'Mixed');
	
		var: 'database_list' = (array);
		
		if: ($dialog_action >> 'Unassign All');

			// Get a list of databases for the current host
			var: 'sql' = 'SELECT id FROM security_datasource_databases WHERE id_host > 0';
			inline: -database=(_admin_internaldatabase), -sql=$sql;
				records;
					$database_list->(insert: (field: 'id'));
				/records;	
			/inline;
			
		else;
		
			// Get a list of databases for the current host
			var: 'sql' = 'SELECT id FROM security_datasource_databases WHERE id_host = ' + $groups_actionid;
			inline: -database=(_admin_internaldatabase), -sql=$sql;
				records;
					$database_list->(insert: (field: 'id'));
				/records;	
			/inline;
			
		/if;
			
		if: $database_list->size > 0;
			// Update those databases which have records in security_group_db_map
			var: 'sql' = 'SELECT * FROM security_group_db_map WHERE id_group=' + $groups_groupid + ' AND id_database in (' + $database_list->(join: ',') + ')';
			inline: -database=(_admin_internaldatabase), -sql=$sql;
				records;
					var: 'allow' = (field: 'allow')->(split: ',');
					var: 'deny' = (field: 'deny')->(split: ',');
					
					$allow->(removeall: '');
					$deny->(removeall: '');
						
					var: 'update' = false;
					
					if: ($host_sql >> 'Allow') && (($deny >> 'Q') || !($allow >> 'Q'));
						var: 'update' = true;
						$deny->(removeall: 'Q');
						$allow->(removeall: 'Q');
						$allow->(insert: 'Q');
					else: ($host_sql >> 'Deny') && (($allow >> 'Q') || !($deny >> 'Q'));
						var: 'update' = true;
						$deny->(removeall: 'Q');
						$allow->(removeall: 'Q');
						$deny->(insert: 'Q');
					else: ($host_sql >> 'Ignore') && (($allow >> 'Q') || ($deny >> 'Q'));
						var: 'update' = true;
						$deny->(removeall: 'Q');
						$allow->(removeall: 'Q');
					/if;
					
					if: $update == true;
						if: $allow->size == 0 && $deny->size == 0;
							var: 'sql' = 'DELETE FROM security_group_db_map WHERE id=' + (field: 'id');
							inline: -database=(_admin_internaldatabase), -sql=$sql;
							/inline;
						else: $allow->size == 0;
							var: 'sql' = 'UPDATE security_group_db_map SET allow=NULL, deny=\'' + $deny->(join: ',') + '\' WHERE id=' + (field: 'id');
							inline: -database=(_admin_internaldatabase), -sql=$sql;
							/inline;
						else: $deny->size == 0;
							var: 'sql' = 'UPDATE security_group_db_map SET allow=\'' + $allow->(join: ',') + '\', deny=NULL WHERE id=' + (field: 'id');
							inline: -database=(_admin_internaldatabase), -sql=$sql;
							/inline;
						else;
							var: 'sql' = 'UPDATE security_group_db_map SET allow=\'' + $allow->(join: ',') + '\', deny=\'' + $deny->(join: ',') + '\' WHERE id=' + (field: 'id');
							inline: -database=(_admin_internaldatabase), -sql=$sql;
							/inline;
						/if;
					/if;
					
					// Remove those databases that have been processed from list
					$database_list->(removeall: (field: 'id_database'));
				/records;	
			/inline;
		/if;
		
		if: ($database_list->size > 0) && ( ($host_sql >> 'Allow') || ($host_sql >> 'Deny') );
			// Update those databases which don't have records in security_group_db_map
			
			iterate: $database_list, (var: 'database_id');
				if: ($host_sql >> 'Allow');
						var: 'sql' = 'INSERT security_group_db_map (id_database,id_group,allow,deny) VALUES (' + $database_id + ',' + $groups_groupid + ',\'Q\',NULL)';
						inline: -database=(_admin_internaldatabase), -sql=$sql;
						/inline;
				else: ($host_sql >> 'Deny');
						var: 'sql' = 'INSERT security_group_db_map (id_database,id_group,allow,deny) VALUES (' + $database_id + ',' + $groups_groupid + ',NULL,\'Q\')';
						inline: -database=(_admin_internaldatabase), -sql=$sql;
						/inline;
				/if;
			/iterate;
		/if;

		inline: -database=(_admin_internaldatabase), -sql='flush tables'; /inline;
		_security_flushcaches;
	/if;

	var: 'groups_action' = 'Detail';

else: $groups_action >> 'List Databases';

	// Redirect
	var: 'link' = $admin_link + '&tab3=databases' +
		'&groups_connectorid=' + $groups_connectorid +
		'&groups_hostid=' + $groups_hostid;
	redirect_url: $link;	
	output: '<a href="' + $link + '">' + $link + '</a>', -encodenone;	
	abort;

/if;


// 
// Add Permissions to groups_databasemap for current group
//
if: ($groups_groupdetail != null);

	var: 'hosts_perms' = (map);

	var: 'sql' = 'SELECT * FROM security_group_db_map ' +
		'LEFT JOIN security_datasource_databases ON security_group_db_map.id_database = security_datasource_databases.id ' +
		'WHERE security_group_db_map.id_group = ' + $groups_groupdetail->(find: 'id');

	inline: -database=(_admin_internaldatabase), -sql=$sql;

		records;
			
			var: 'temp' = $hosts_perms->(find: (field: 'id_host'));
			if: $temp == null;
				var: 'temp' = (map: 'allow'=false, 'deny'=false);
			/if;
			
			$temp->(insert: 'allow' = ($temp->(find: 'allow') || ((field: 'allow') >> 'Q')));
			$temp->(insert: 'deny' = ($temp->(find: 'deny') || ((field: 'deny') >> 'Q')));
			
			$hosts_perms->(insert: (field: 'id_host') = $temp);
			
		/records;

	/inline;
/if;

var: 'temp' = (_admin_defaulthost: $groups_hostid, $groups_hostmap);
if: ($temp != null);
	var: 'groups_hostid' = $temp->first;
	var: 'groups_hostdetail' = $temp->second;
	var: 'groups_hostname' = $groups_hostdetail->(find: 'name');
	var: 'groups_hostalias' = $groups_hostdetail->(find: 'alias');
else;
	var: 'groups_hostid' = 0;
/if;


//
// Process Navigation
//

if: $groups_navigation >> 'Prev';
	$groups_skip -= 10;
else: $groups_navigation >> 'Next';
	$groups_skip += 10;
else: $groups_navigation >> 'First';
	$groups_skip = 1;
else: $groups_navigation >> 'Last';
	$groups_skip = $groups_hostmap->size;
else: $groups_navigation >> 'Jump';
	$groups_skip = integer: $groups_jump;
/if;

var: 'found_count' = $groups_hostmap->size;
var: 'groups_skip' = integer: (math_max: 1, (math_min: $groups_skip, $found_count));
var: 'shown_first' = $groups_skip;
var: 'shown_last' = integer: (math_min: $found_count, $groups_skip + 9);
var: 'shown_count' = ($shown_last - $shown_first + 1);

?>
