<?LassoScript

//
// Variables
//

_admin_addvar: 'groups_action', -default='None', -override=(action_param: 'groups_action', (action_param: 'groups_action', -count));
_admin_addvar: 'category_action', -default='None', -override=(action_param: 'category_action', (action_param: 'category_action', -count));
_admin_addvar: 'tag_action', -default='None', -override=(action_param: 'tag_action', (action_param: 'tag_action', -count));

_admin_addvar: 'groups_categoryid', -override=(action_param: 'groups_categoryid');

var: 'need_flush' = false;

//
// Tag Map
//

var: 'tags_category' = (array:
	'Administration' = (array: 'Admin_CreateUser','Admin_GroupAssignUser','Admin_GroupRemoveUser','Admin_GroupListUsers','Admin_ChangeUser','Admin_ListGroups'),
	'Custom Tag' = (array: 'Define_Tag','Define_Type','Local','Local_Defined','Locals','Named_Param','Params','Params_Up','PostCondition','PreCondition','Return','Return_Value','Self'),
	'Database' = (array: 'Database_ChangeField','Database_CreateField','Database_CreateTable','Database_RemoveField','Database_RemoveTable'),
	'File' = (array: 'File_Control','File_Copy','File_Create','File_CreationDate','File_CurrentError','File_Delete','File_Exists','File_GetLineCount','File_GetSize','File_IsDirectory','File_ListDirectory','File_ModDate','File_Move','File_Read','File_ReadLine','File_Rename','File_SetSize','File_Write'),
	'Include' = (array: 'Include','Include_URL','Include_Raw','Library'),
	'Technical' = (array: 'LassoApp_Create','LassoApp_Dump','LassoApp_Link','Process','Sleep','TCP_Close','TCP_Open','TCP_Send'),
	'Utility' = (array: 'Email_Send','Event_Schedule','Log','Log_Critical','Log_Detail','Log_Warning')
);

var: 'tags_alias' = (array:
	'Database_ChangeField' = (array: 'Database_ChangeColumn'),
	'Database_CreateField' = (array: 'Database_CreateColumn'),
	'Database_RemoveField' = (array: 'Database_RemoveColumn'),
	'File_ListDirectory' = (array: 'Directory_Lister','Directory_NameItem','DirectoryNameItem'),
	'Include' = (array: 'Include_NoDebug')
);

var: 'tags_status' = (map);
var: 'tags_ids' = (array);

var: 'temp_array' = $tags_category;
$temp_array->(merge: $tags_alias);
iterate: $temp_array, (var: 'item');
	var: 'category' = $item->first;
	var: 'tags' = $item->second;

	var: 'sql' = 'SELECT DISTINCT security_tags.id,security_tags.name FROM security_tags ' +
		'LEFT JOIN security_group_tag_map ON ((security_tags.id = security_group_tag_map.id_tag) AND (security_group_tag_map.id_group = ' + $groups_groupid + ')) ' +
		'WHERE lcase(name) IN (\'' + (string_lowercase: $tags->(join: '\',\'')) + '\')';

	inline: -database=(_admin_internaldatabase), -sql=$sql, -maxrecords='all';
		var: 'temp' = (map);
		records;
			loop: (field_name: -count);
				$temp->(insert: (field_name: loop_count) = (field: (field_name: loop_count)));
			/loop;
			$tags_status->(insert: (field: 'name') = $temp);
			$tags_ids->(insert: (field: 'id'));
		/records;
	/inline;

	// Fix missing tags by inserting them into security_tags manually.
	var: 'missing' = (array);
	iterate: $tags, (var: 'tag');
		if: !($tags_status >> $tag);
			$missing->(insert: $tag);
		/if;
	/iterate;

	if: $missing->size > 0;
		var: 'sql' = 'INSERT INTO security_tags (name, id_site, enabled) VALUES ';
		iterate: $missing, (var: 'tag');
			$sql += '(\'' + $tag + '\',1,\'Y\'' + '), ';
		/iterate;
		$sql->(removetrailing: ', ');

		inline: -database=(_admin_internaldatabase), -sql=$sql, -maxrecords='all';
		/inline;

	var: 'sql' = 'SELECT DISTINCT security_tags.id,security_tags.name FROM security_tags ' +
		'LEFT JOIN security_group_tag_map ON ((security_tags.id = security_group_tag_map.id_tag) AND (security_group_tag_map.id_group = ' + $groups_groupid + ')) ' +
		'WHERE lcase(name) IN (\'' + (string_lowercase: $missing->(join: '\',\'')) + '\')';

		inline: -database=(_admin_internaldatabase), -sql=$sql, -maxrecords='all';
			records;
				var: 'temp' = (map);
				loop: (field_name: -count);
					$temp->(insert: (field_name: loop_count) = (field: (field_name: loop_count)));
				/loop;
				$tags_status->(insert: (field: 'name') = $temp);
				$tags_ids->(insert: (field: 'id'));
			/records;
		/inline;
	/if;

/iterate;



//
// Category Map
//

var: 'groups_categorydetail' = null;
if: ($groups_categoryid != '');
	var: 'groups_categorydetail' = $tags_category->(find: $groups_categoryid)->(get:1)->second;
/if;


//
// Process Action
//

var: 'delete_ids' = (array);
var: 'allow_ids' = (array);
var: 'deny_ids' = (array);

if: ($category_action >> 'Unassign All') || ($category_action >> 'Assign') || ($category_action >> 'Allow All') || ($category_action >> 'Deny All');

	if: ($category_action >> 'Unassign All');
		var: 'delete_ids' = $tags_ids;
	else: ($category_action >> 'Allow All');
		var: 'allow_ids' = $tags_ids;
		var: 'delete_ids' = $tags_ids;
	else: ($category_action >> 'Deny All');
		var: 'deny_ids' = $tags_ids;
		var: 'delete_ids' = $tags_ids;
	else: ($category_action >> 'Assign');

		iterate: $tags_category, (var: 'item');
			var: 'cat_name' = $item->first;
			var: 'cat_tags' = $item->second;

			if: (action_param: 'category_' + $cat_name) == 'Mixed';
				// Nothing
			else: (action_param: 'category_' + $cat_name) == 'Allow';
				iterate: $cat_tags, (var: 'tag');
					$allow_ids->(insert: $tags_status->(find: $tag)->(find: 'id'));
					var: 'alias' = $tags_alias->(find: $tag);
					if: ($alias != (array)) && ($alias->size > 0);
						iterate: $alias->(get:1)->second, (var: 'tag2');
							$allow_ids->(insert: $tags_status->(find: $tag2)->(find: 'id'));
						/iterate;
					/if;
				/iterate;
			else: (action_param: 'category_' + $cat_name) == 'Deny';
				iterate: $cat_tags, (var: 'tag');
					$deny_ids->(insert: $tags_status->(find: $tag)->(find: 'id'));
					var: 'alias' = $tags_alias->(find: $tag);
					if: ($alias != (array)) && ($alias->size > 0);
						iterate: $alias->(get:1)->second, (var: 'tag2');
							$deny_ids->(insert: $tags_status->(find: $tag2)->(find: 'id'));
						/iterate;
					/if;
				/iterate;
			else: (action_param: 'category_' + $cat_name) == 'Ignore';
				iterate: $cat_tags, (var: 'tag');
					$delete_ids->(insert: $tags_status->(find: $tag)->(find: 'id'));
					var: 'alias' = $tags_alias->(find: $tag);
					if: ($alias != (array)) && ($alias->size > 0);
						iterate: $alias->(get:1)->second, (var: 'tag2');
							$delete_ids->(insert: $tags_status->(find: $tag2)->(find: 'id'));
						/iterate;
					/if;
				/iterate;
			/if;

		/iterate;
		$delete_ids->(merge: $allow_ids);
		$delete_ids->(merge: $deny_ids);

	/if;

	var: 'need_flush' = true;

	var: 'groups_action' = 'None';

else: ($tag_action >> 'Unassign All') || ($tag_action >> 'Assign') || ($tag_action >> 'Allow All') || ($tag_action >> 'Deny All');

	var: 'cat_ids' = (array);
	iterate: $groups_categorydetail, (var: 'tag');
		$cat_ids->(insert: $tags_status->(find: $tag)->(find: 'id'));
	/iterate;

	if: ($tag_action >> 'Unassign All');
		var: 'delete_ids' = $cat_ids;
	else: ($tag_action >> 'Allow All');
		var: 'allow_ids' = $cat_ids;
		var: 'delete_ids' = $cat_ids;
	else: ($tag_action >> 'Deny All');
		var: 'deny_ids' = $cat_ids;
		var: 'delete_ids' = $cat_ids;
	else: ($tag_action >> 'Assign');

		iterate: $groups_categorydetail, (var: 'tag');
			if: (action_param: 'tag_' + $tag) == 'Allow';
				$allow_ids->(insert: $tags_status->(find: $tag)->(find: 'id'));
				var: 'alias' = $tags_alias->(find: $tag);
				if: ($alias != (array)) && ($alias->size > 0);
					iterate: $alias->(get:1)->second, (var: 'tag2');
						$allow_ids->(insert: $tags_status->(find: $tag2)->(find: 'id'));
					/iterate;
				/if;
			else: (action_param: 'tag_' + $tag) == 'Deny';
				$deny_ids->(insert: $tags_status->(find: $tag)->(find: 'id'));
				var: 'alias' = $tags_alias->(find: $tag);
				if: ($alias != (array)) && ($alias->size > 0);
					iterate: $alias->(get:1)->second, (var: 'tag2');
						$deny_ids->(insert: $tags_status->(find: $tag2)->(find: 'id'));
					/iterate;
				/if;
			else: (action_param: 'tag_' + $tag) == 'Ignore';
				$delete_ids->(insert: $tags_status->(find: $tag)->(find: 'id'));
				var: 'alias' = $tags_alias->(find: $tag);
				if: ($alias != (array)) && ($alias->size > 0);
					iterate: $alias->(get:1)->second, (var: 'tag2');
						$delete_ids->(insert: $tags_status->(find: $tag2)->(find: 'id'));
					/iterate;
				/if;
			/if;
		/iterate;
		$delete_ids->(merge: $allow_ids);
		$delete_ids->(merge: $deny_ids);

	/if;

	var: 'need_flush' = true;

	var: 'groups_action' = 'Detail';

/if;

if: ($delete_ids->size > 0) || ($allow_ids->size > 0) || ($deny_ids->size > 0);

	if: $delete_ids->size > 0;
		var: 'sql' = 'DELETE FROM security_group_tag_map WHERE id_group = ' + $groups_groupid + ' AND id_tag in (' + $delete_ids->(join: ',') + ')';
		inline: -database=(_admin_internaldatabase), -sql=$sql, -maxrecords='all';
		/inline;
	/if;

	if: $allow_ids->size > 0;
		var: 'sql' = 'INSERT INTO security_group_tag_map (id_group,id_tag,allow_exec) ' +
			'SELECT ' + $groups_groupid + ' AS id_group, id AS id_tag, \'Y\' AS allow_exec ' +
			'FROM security_tags WHERE id in (' + $allow_ids->(join: ',') + ')';
		inline: -database=(_admin_internaldatabase), -sql=$sql, -maxrecords='all';
		/inline;
	/if;

	if: $deny_ids->size > 0;
		var: 'sql' = 'INSERT INTO security_group_tag_map (id_group,id_tag,allow_exec) ' +
			'SELECT ' + $groups_groupid + ' AS id_group, id AS id_tag, \'N\' AS allow_exec ' +
			'FROM security_tags WHERE id in (' + $deny_ids->(join: ',') + ')';
		inline: -database=(_admin_internaldatabase), -sql=$sql, -maxrecords='all';
		/inline;
	/if;

	var: 'need_flush' = true;

/if;


//
// Flush Cache If Needed
//

if: (var: 'need_flush') == true;
	inline: -database=(_admin_internaldatabase), -sql='flush tables'; /inline;
	_security_flushcaches;
/if;


//
// Find Tag Permissions
//

var: 'tags_status' = (map);

var: 'sql' = 'SELECT security_tags.id,security_tags.name,security_tags.enabled,security_group_tag_map.allow_exec FROM security_tags ' +
	'LEFT JOIN security_group_tag_map ON ((security_tags.id = security_group_tag_map.id_tag) AND (security_group_tag_map.id_group = ' + $groups_groupid + ')) ' +
	'WHERE security_tags.id IN (' + $tags_ids->(join: ',') + ')';

inline: -database=(_admin_internaldatabase), -sql=$sql, -maxrecords='all';
	var: 'temp' = (map);
	records;
		loop: (field_name: -count);
			$temp->(insert: (field_name: loop_count) = (field: (field_name: loop_count)));
		/loop;
		$tags_status->(insert: (field: 'name') = $temp);
	/records;
/inline;

?>
