<?LassoScript

//
// Store Search Variables in Session
//

session_addvar: -name='_reference', 'browse_legacy_category';
session_addvar: -name='_reference', 'browse_legacy_maxrecords';
session_addvar: -name='_reference', 'browse_legacy_skiprecords';
session_addvar: -name='_reference', 'browse_legacy_found_count';
session_addvar: -name='_reference', 'browse_legacy_mode';
session_addvar: -name='_reference', 'browse_legacy_inline';

//
// Define Default Variables
//

if: (var_defined: 'browse_legacy_mode');

	//
	// Base Inline
	//

	variable: 'browse_legacy_inline' = $ref_tag_inline;

	//
	// Navigation Parameters
	//

	if: (var_defined: 'browse_legacy_navigation') && (var_defined: 'browse_legacy_found_count') && (var_defined: 'browse_legacy_skiprecords') && (var_defined: 'browse_legacy_maxrecords');
		if: ($browse_legacy_navigation >> 'Prev');
			var: 'temp' = (math_min: $browse_legacy_found_count, (math_max: 0, (math_sub: $browse_legacy_skiprecords, $browse_legacy_maxrecords)));
			$browse_legacy_inline->(insert: -SkipRecords=$temp);
		else: ($browse_legacy_navigation >> 'Next');
			var: 'temp' = (math_min: $browse_legacy_found_count, (math_max: 0, (math_add: $browse_legacy_skiprecords, $browse_legacy_maxrecords)));
			$browse_legacy_inline->(insert: -SkipRecords=$temp);
		/if;
	/if;

	//
	// Search Parameters
	//

	$browse_legacy_inline->(insert: -search='');
	$browse_legacy_inline->(insert: -maxrecords=15);
	$browse_legacy_inline->(insert: $ref_tag_display='Y');
	$browse_legacy_inline->(insert: $ref_tag_basic='N');
	$browse_legacy_inline->(insert: -SortField=$ref_tag_category);
	$browse_legacy_inline->(insert: -SortField=$ref_tag_name);
	$browse_legacy_inline->(insert: $ref_tag_category=(var: 'browse_legacy_category'));

	//
	// Perform the Search
	//

	inline: $browse_legacy_inline, -inlinename='browse_legacy_results';
	  	var: 'browse_legacy_found_count' = (found_count);
	  	var: 'browse_legacy_shown_count' = (shown_count);
	  	var: 'browse_legacy_shown_first' = (shown_first);
	  	var: 'browse_legacy_shown_last' = (shown_last);
	  	var: 'browse_legacy_maxrecords' = (maxrecords_value);
	  	var: 'browse_legacy_skiprecords' = (skiprecords_value);
	/inline;
/if;

?>
