<?LassoScript

// replacement for old repetition functionality
define_type:'repetition';

	//
	// IMPORTANT - [Repetition] has been deprecated.
	//
	// [If: (Repetition == 2)] should be changed to [If: (Loop_Count % 2 == 0)]
	//

    define_tag: 'onCompare', -required='modulo';
        
        return: (((integer: $__loop_count__->last) % #modulo) != 0);
        
    /define_tag;
    
/define_type;


// replacement for the old client_ip == '127.0.0.*' functionality
define_type:'client_ip';
	local: 'data' = _client_ip_old;

	// do smart comparisons
	define_tag:'onCompare';

		// params may be a list item comma delimited items
		// these are OR not AND

		local: 'mainList' = (string: params->(get: 1))->(split: ',');

		if: #mainList->size == 0; // no items
			return: -1;
		/if;

		local: 'lhs' = self->data->(split: '.');

		iterate: #mainList, (local: 'i');
			#i->trim;

			if: (string_isdigit: #i);
				#i = (_ip_frominteger: #i);
			/if;

			if: #i->size == 0;
				return: -1;
			/if;

			local: 'rhs' = #i->(split: '.');
			local: 'result' = 0;

			iterate: #rhs, (local: 'j');
				if: (#lhs->(get: (loop_count)) != #j) && (#j != '*');
					#result = -1;
				/if;
			/iterate;
			return: #result;
		/iterate;

		return: -1; // just in case
	/define_tag;

	// when called normally, need to output the client_ip_old tag
	define_tag:'onConvert';
		return: self->data;
	/define_tag;
/define_type;

// turn a ip address into an integer
define_tag: '_ip_tointeger',
	-required = 'ip',
	-type = 'string';

	fail_if: #ip->(split: '.')->size != 4, -1, 'Incorrect quad decimal IP address';

	local:
		'result' = 0,
		'm' = 256 * 256 * 256;

	iterate: #ip->(split: '.'), (local: 'i');
		#result += (integer: #i) * #m;
		#m /= 256;
	/iterate;

	return: #result;
/define_tag;

// turn an integer into an IP address
define_tag: '_ip_frominteger',
	-required = 'ip';

	local:
		'x' = (integer: #ip),
		'result' = array,
		'm' = 256 * 256 * 256;

	loop: 4;
		#result->(insert: #x / #m);
		#x %= #m;
		#m /= 256;
	/loop;

	return: (string: #result->(join: '.'));
/define_tag;

// replacement for the old client_address == '*.edu' functionality
define_type: 'client_address';
	local: 'data' = _client_address_old;

	// do smart comparisons
	// works almost the same as client_ip, except compares from back to front
	define_tag: 'onCompare';

		// simple check to see if they do equal each other first
		if: (string: params->(get: 1)) == self->data;
			return: 0;
		/if;

		// params may be a comma dlist item comma delimited items
		local:'mainList' = (string: params->(get: 1))->(split:',');

		if: #mainList->size == 0; // no items
			return: -1;
		/if;

		iterate: #mainList, (local: 'i');
			#i->trim;

			#i->(replace: '.', '\\.');
			#i->(replace: '*', '.*');
			protect;
				if: (string_findregexp: -find = #i, self->data)->size == 1;
					return: 0;
				/if;
				handle_error;
					return: -1;
				/handle_error;
			/protect;
		/iterate;

		return: -1;
	/define_tag;

	// when called normally, need to output the client_ip_old tag
	define_tag:'onConvert';
		return: self->'data';
	/define_tag;

/define_type;

define_type:'client_addr', 'client_address';
/define_type;

?>