<?LassoScript

	// This file is the only file called at startup by Lasso.
	// This file must include all other files in startup.lassoapp
	// which need to be called.

	Auth_Admin;

// Log Startup Message

	log_critical: 'Lasso Professional ' + (Lasso_Version: -LassoVersion) + ' Started';

// Set Default Error Preferences

	 library: (lassoapp_link: 'errorDefaults.lasso'); 

// Check/Repair Databases

	 library: (lassoapp_link: 'database_check.lasso'); 

// Load Lasso Tag Libraries

	Log_Warning: 'Lasso Tags: Defining Lasso 7 Tags';

	// Global variable tags [Global] [Global_Defined]
	 library: (lassoapp_link: 'globals.lasso'); 

	// Cache tags [Cache] ... [/Cache] [Cache_Object]
	 library: (lassoapp_link: 'Cache.lasso'); 

	// Security Tags
	 library: (lassoapp_link: 'security.lasso'); 

	// Utility Tags [Named_Param] [Client_...] tags
	 library: (lassoapp_link: 'utility.lasso'); 

	// Lasso MySQL table/field creation tags
	 library: (lassoapp_link: 'tableGoodiesLibrary.lasso'); 

	// Link tags
	 library: (lassoapp_link: 'link_tags.lasso'); 

	// Valdiation Tags tags
	 library: (lassoapp_link: 'valid.lasso'); 

	// Lasso [..._Serve] Tags
	 library: (lassoapp_link: 'serveLibrary.lasso'); 

	// Lasso Professional 6 Semephores, Pipes, and Read/Write Locks
	 library: (lassoapp_link: 'thread_semaphore.lasso'); 
	 library: (lassoapp_link: 'thread_pipe.lasso'); 
	 library: (lassoapp_link: 'thread_rwlock.lasso'); 

	// Lasso [XML_...] Tags
	 library: (lassoapp_link: 'xml_tags.lasso'); 

// Load Lasso 3 Compatibility Tag Libraries

	Log_Warning: 'Lasso Tags: Defining Lasso 3 Compatibility Tags';

	// Lasso 3 compatibility types [Repetition], [Client_Address] [Client_IP]
	 library: (lassoapp_link: 'compatibility.lasso'); 

	// Lasso 3 compatibility tags [Math_ConvertEuro], etc.
	 library: (lassoapp_link: 'MiscLibrary.lasso'); 

	// Lasso 3 list tags
	 library: (lassoapp_link: 'list_tags.lasso'); 

	// The [Stock_Quote] example tag.
	 library: (lassoapp_link: 'tcpGoodiesLibrary.lasso'); 

	// Locale tags
	 library: (lassoapp_link: 'locale.lasso'); 

	// Image tags (Stub if X11 is missing)
	 library: (lassoapp_link: 'image_tags.lasso'); 

// Create Utility Tables and Start Background Processes

	// Session tracker table in site database
	 library: (lassoapp_link: 'sessiontrackerinit.lasso'); 

	// Create preferences table and define helper tags
	 library: (lassoapp_link: 'LassoAdminStartup.lasso'); 

	// Email Queue and [Email_Send] tag
	 
		library: (lassoapp_link: 'smtpLibrary.lasso');
		_SMTP_Init;
		_SMTP_EmailWatcher;
	 
	// Turn on Strict Syntax
	 library: (lassoapp_link: 'StrictSyntax.lasso'); 

	// Maintenance Queue
	// Requires: LassoAdminStarutp.LassoApp
	 library: (lassoapp_link: 'maintenanceLibrary.lasso'); 

	// Schedule Queue and [Event_Schedule] tag
	 library: (lassoapp_link: 'scheduleLibrary.lasso'); 

	// XML_RPC type
	library: (lassoapp_link: 'xml_rpc.lasso');
	
	// RPC Introspection
	library: (lassoapp_link: 'RPC_introspect.lasso'); 

// Lasso Security

	// Load Lasso Security Modifications
	 library: (lassoapp_link: 'LassoSecurity.lasso'); 

// Set Error Preferences (defaults used until this point)

	 library: (lassoapp_link: 'errorSetup.lasso'); 

// Reload internal data source, and Dump Startup.LassoApp

	// Ensure that any altered database tables are loaded
	_datasource_reload: 1;

	// Call lassoapp_dump asynchronously so it occurs after we finish executing.
	{ Sleep: 15000; LassoApp_Dump: 'Startup.LassoApp' }->AsAsync;

?>
