<?LassoScript
	// This startup script is enclosed in a compound expression so the variables will not
	// show up in the list of global variables.

	{
	
		Log_Warning: 'Lasso Errors: Setting User Preferences';

		if: (var_defined: '_log_settings') && ($_log_settings->type == 'array');
		
			iterate: $_log_settings, (local: 'temp');

				if: (#temp->type == 'array') && (#temp->size == 4);
				
					log_setdestination: #temp->(get:1), #temp->(get:2), #temp->(get:3), #temp->(get:4);
				/if;

			/iterate;
			
		else;
		
			log_setdestination: log_level_critical, log_destination_file, log_destination_database, log_destination_console;
			log_setdestination: log_level_detail, 0, 0, log_destination_console;
			log_setdestination: log_level_warning, 0, 0, log_destination_console;
			
		/if;
		
		// Remove _log_settings so it doesn't pollute the global variable space
		if: (vars->(keys) >> '_log_settings');
			vars->(remove: '_log_settings');
		/if;
		
	}->(run);
?>