<!--	Library of routines to perform interesting TCP functions like [Stock_Quote] and [NSLookup]
	Problems:

	History:
	10/17/2001	GLH - moved return value to prevent leakage of 9 handles on Windows
	01/17/2001	GLH - use new substring search syntax
				GLH - use new parameter-passing syntax
				GLH - change Tag to Define_Tag
	11/22/2000	GLH - Initial work
-->

<!--------------------------------------------------------------------->
<!-- Stock_Quote:
	Problems:

	Inputs:
		*unnamed*	string, such as "AAPL" or "SMSI" indicates which stock to get info for

	Outputs:
		Text from Yahoo stock-quote engine, dollar value of stock requested
-->

<?LassoScript

	Define_Tag: 'Stock_Quote';

		Local: 'Timeout' = 15;	// 15-second TCPIP connection timeout

		// find incoming param
		Local: 'ticker' = (params)->(get: 1);

		TCP_Open: -Host = 'quote.yahoo.com', -Port = '80', -Name = '_stock_quote', -Timeout = #Timeout;

		Local: 'Answer' = (TCP_Send: -Name = '_stock_quote', 'GET /d/quotes.csv?s=' + #ticker + '&f=l1 HTTP/1.0\r\n\r\n', -Timeout = #Timeout, -DontWait = false);

		If: (Error_CurrentError: -ErrorCode) == 0;
			local: 'answer' = #Answer->(substring: (#Answer->(find: '\r\n\r\n') + 4));
		/if;

		TCP_Close: -Name = '_stock_quote';

		Return: #answer;

	/Define_Tag;

?>