<?LassoScript

define_type:'thread_pipe';
	local: 'data'=array;
	local: 'dataLock'=thread_lock;
	local: 'event'=thread_event;

	define_tag:'get', -optional='timeout';
		if: local:'timeout' == null;
			#timeout = (-1);
		/if;
		local: 'retVal' = null;

		// if there's already data waiting, return it
		if: self->data->size > 0 && self->dataLock->lock:#timeout;
			#retVal = @self->data->last;
			self->data->remove;
			return: @#retVal;
			handle;
				self->dataLock->unlock;
			/handle;
		/if;

		if: self->event->wait:#timeout;
			if: self->data->size > 0 && self->dataLock->lock:#timeout;
				#retVal = @self->data->last;
				self->data->remove;
				return: @#retVal;
				handle;
					self->dataLock->unlock;
				/handle;
			/if;
		/if;
		return: null;
	/define_tag;

	define_tag:'set', -optional='payload', -optional='timeout';
		if: local:'timeout' == null;
			#timeout = (-1);
		/if;
		if: local:'payload' != null;
			self->dataLock->lock:#timeout;

			self->data->(insert:#payload, 1);

			handle;
				self->dataLock->unlock;
			/handle;
		/if;
		self->event->signal;
	/define_tag;

/define_type;

?>