<?LassoScript

define_type:'thread_semaphore';

	local: 'value' = 0;
	local: 'valueLock' = thread_lock;
	local: 'event' = thread_event;

	local: 'maxValue' = { if: params->size > 0; return: params->get:1; /if; return: 1; }->eval;

	define_tag:'increment', -required='toInc', -optional='timeout';

		precondition: #toInc > 0, '[Thread_Semaphore] The increment value must be positive.';

		if: local:'timeout' == null;
			#timeout = (-1);
		/if;
		#toInc = (integer: #toInc);
		
		if: self->'valueLock'->lock:#timeout;
			if: (self->'value' + #toInc) <= self->'maxValue';
				(self->'value') += #toInc;
				return: true;
			else;
				self->'valueLock'->unlock;
				if: self->'event'->wait:#timeout;
					if: self->'valueLock'->lock:#timeout;
						if: (self->'value' + #toInc) <= self->'maxValue';
							self->'value' += #toInc;
							return: true;
						/if;
					/if;
				else;
					return: false;
				/if;
			/if;
			handle;
				self->'valueLock'->unlock;
			/handle;
		/if;
	/define_tag;

	define_tag:'decrement', -required='toDec', -optional='timeout';

		precondition: #toDec > 0, '[Thread_Semaphore] The decrement value must be positive.';

		if: local:'timeout' == null;
			#timeout = (-1);
		/if;
		#toDec = (integer: #toDec);

		if: self->'valueLock'->lock:#timeout;
			self->'value' = (integer: (math_max: 0, (self->'value' - #toDec)));
			self->'event'->signalAll;
			handle;
				self->'valueLock'->unlock;
			/handle;
		/if;
	/define_tag;

/define_type;

?>
