#!/bin/sh

if [ `id -u` != 0 ]; then
	echo ""

	if [ -f /usr/bin/sudo ]; then
		/usr/bin/sudo -p "You must have administrator privileges to run this script.  Enter the password for %u: " "$0"
	else
		echo "This script must be run by the system administrator."
	fi

else
	echo ""

	if [ "$1" = "safe" ]; then
		TYPE="SAFE"
	else
		TYPE="NORMAL"
	fi

	running=`/sbin/pidof LassoService`

	if [ $running ]; then
		echo "Another instance of Lasso Service is already running."
		echo ""
		echo "Stopping other Lasso Service."
		kill -s HUP $running
		echo ""
	fi

	echo "Starting Lasso Service in console mode."
	echo ""
	echo "Use Control-C or close the window to close LassoService."

	HOME=/usr/local/Lasso\ Professional\ 7
	umask 002

	if [ "$TYPE" = "SAFE" ]; then
		chmod 000 /usr/local/Lasso\ Professional\ 7/LassoModules/*
	else
		chmod 775 /usr/local/Lasso\ Professional\ 7/LassoModules/*
	fi

	cd /usr/local/Lasso\ Professional\ 7
	./LassoService
fi
