#!/bin/sh

running=`/sbin/pidof LassoService`

if [ $running ]; then

	if [ `id -u` != 0 ]; then
		echo ""

		if [ -f /usr/bin/sudo ]; then
			/usr/bin/sudo -p "You must have administrator privileges to run this script.  Enter the password for %u: " "$0"
		else
			echo "This script must be run by the system administrator."
		fi

	else

		# kill the lasso shell if it is running
		kill -INT `cat /tmp/LassoService.pid`

		sleep 1

		# check to see if the pid has gone away
		if ( test -f /tmp/LassoService.pid ) then
			LASSOSHELL=`ps ax -opid,command | sed -n 's/[ ]*\([0-9]*\)[ ]*sh\ .*LassoService.sh.*/\1/p'`

			if ( test $LASSOSHELL ) then
				echo "Force kill"
				# kill the wrapper
				kill -9 $LASSOSHELL 2> /dev/null
				# kill the service
				kill -9 `cat /tmp/LassoService.pid` 2> /dev/null
				sleep 1
			fi
		fi

		counter=0
		dead=0

		echo -n "Stopping Lasso Service..."

		while ( (test $counter -lt 60) && (test $dead -eq 0) )
		do
			if ( ! test `/sbin/pidof LassoService` ) then
				dead=1
			fi
			echo -n "."
			counter=$((counter+1))
			sleep 1
		done

		fail=0

		if ( test `/sbin/pidof LassoService` ) then
			echo "Fail"
			fail=1
		else
			echo "Done"
		fi

		if ( test -f /tmp/LassoService.pid || test $fail -eq 1 ) then
			echo "There was a problem stopping the Lasso Service."
		else
			echo "Lasso Service has been successfully stopped."
			echo ""
			echo "Use startLassoService.command to restart Lasso Service."
		fi
	fi

else

	echo "Lasso Service is not running."
	echo ""
	echo "Use startLassoService.command to start Lasso Service."

fi
